############################################################################
# Script:      Optimización.R
# Objective:   Analizando la estrategia
# Author:      Mario Pisa
# Date:        2019/03/12
# 
# References:  
# TO-DO:       
############################################################################

##############################
# PARAMETER OPTIMIZATION
##############################
save.strategy(strategy.st)
#################################
# Parameter Optimization
#################################
.nSlow = (50:200)
.nFast = (10:100)


load.strategy(strategy.st)

add.distribution(
  strategy.st, 
  paramset.label = 'EMA', 
  component.type = 'indicator', 
  component.label = 'nSlow', 
  variable = list(n = .nSlow), 
  label = 'nSLOW'
)

add.distribution(
  strategy.st, 
  paramset.label = 'EMA', 
  component.type = 'indicator', 
  component.label = 'nFast', 
  variable = list(n = .nFast), 
  label = 'nFAST'
)

add.distribution.constraint(
   strategy.st,
   paramset.label = 'EMA',
   distribution.label.1 = 'nFAST',
   distribution.label.2 = 'nSLOW',
   operator = '>',
   label = 'cEMA'
)

# save.strategy(strategy.st)
### want to delete this paramset? 
# delete.paramset(strategy.st, 'EMA')
require(doMC) 
registerDoMC(cores = 4)
# load.strategy(strategy.st)
# Get begin time
t1 <- Sys.time()
results <- apply.paramset(strategy.st, 
                          paramset.label = 'EMA',
                          portfolio.st = portfolio.st, 
                          account.st = account.st,
                          nsamples = 20,
                          audit = NULL, 
                          verbose = TRUE)
# Record end time 
t2 <- Sys.time() 
print(t2 - t1)
# print(results$tradeStats)
View(t(results$tradeStats))


###########################################
#  Walk Forward Analysis
###########################################
x <- mcsim(portfolio.st, account.st, n = 100, replacement = T, use = "equity")
plot(x)
hist(x)
